
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java 程序死锁问题原理及解决方案 / iVAN</title>

    <meta name="description" content="Java 程序死锁问题原理及解决方案  Java 语言通过 synchronized 关键字来保证原子性,这是因为每一个 ob ject 都有一个隐含的锁,这个也称作监视器对象.在进入 synchronized 之前自动获取此内部锁,而一旦离开此方式,无论是完成或者中断都会自动释放锁.显然这是一个独占锁,每个锁请求之间是互斥的.相对于众多高级锁 (Lock/ReadWriteLock 等),synchronized 的代价都比后者要高.但是 synchronzied 的语法比较简单,而且也比较容易使用和理解.Lock 一旦调用了 l">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java 程序死锁问题原理及解决方案</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p> Java 语言通过 synchronized 关键字来保证原子性，这是因为每一个 ob ject 都有一个隐含的锁，这个也称作监视器对象。在进入 synchronized 之前自动获取此内部锁，而一旦离开此方式，无论是完成或者中断都会自动释放锁。显然这是一个独占锁，每个锁请求之间是互斥的。相对于众多高级锁 (Lock/ReadWriteLock 等)，synchronized 的代价都比后者要高。但是 synchronzied 的语法比较简单，而且也比较容易使用和理解。Lock 一旦调用了 lock() 方法获取到锁而未正确释放的话很有可能造成死锁，所以 Lock 的释放操作总是跟在 finally 代码块里面，这在代码结构上也是一次调整和冗余。Lock 的实现已经将硬件资源用到了极致，所以未来可优化的空间不大，除非硬件有了更高的性能，但是 synchronized 只是规范的一种实现，这在不同的平台不同的硬件还有很高的提升空间，未来 Java 锁上的优化也会主要在这上面。既然 synchronzied 都不可能避免死锁产生，那么死锁情况会是经常容易出现的错误，下面具体描述死锁发生的原因及解决方法。</p>
<p> </p>
<p>　　死锁描述</p>
<p>　　死锁是操作系统层面的一个错误，是进程死锁的简称，最早在 1965 年由 Dijkstra 在研究银行家算法时提出的，它是计算机操作系统乃至整个并发程序设计领域最难处理的问题之一。</p>
<p>　　事实上，计算机世界有很多事情需要多线程方式去解决，因为这样才能最大程度上利用资源，才能体现出计算的高效。但是，实际上来说，计算机系统中有很多一次只能由一个进程使用的资源的情况，例如打印机，同时只能有一个进程控制它。在多通道程序设计环境中，若干进程往往要共享这类资源，而且一个进程所需要的资源还很有可能不止一个。因此，就会出现若干进程竞争有限资源，又推进顺序不当，从而构成无限期循环等待的局面。我们称这种状态为死锁。简单一点描述，死锁是指多个进程循环等待它方占有的资源而无限期地僵持下去的局面。很显然，如果没有外力的作用，那么死锁涉及到的各个进程都将永远处于封锁状态。</p>
<p>　　系统发生死锁现象不仅浪费大量的系统资源，甚至导致整个系统崩溃，带来灾难性后果。所以，对于死锁问题在理论上和技术上都必须予以高度重视。</p>
<p> </p>
<p>　　银行家算法</p>
<p>　　一个银行家如何将一定数目的资金安全地借给若干个客户，使这些客户既能借到钱完成要干的事，同时银行家又能收回全部资金而不至于破产。银行家就像一个操作系统，客户就像运行的进程，银行家的资金就是系统的资源。</p>
<p>　　银行家算法需要确保以下四点：</p>
<p>　　当一个顾客对资金的最大需求量不超过银行家现有的资金时就可接纳该顾客;</p>
<p>　　顾客可以分期贷款, 但贷款的总数不能超过最大需求量;</p>
<p>　　当银行家现有的资金不能满足顾客尚需的贷款数额时，对顾客的贷款可推迟支付，但总能使顾客在有限的时间里得到贷款;</p>
<p>　　当顾客得到所需的全部资金后，一定能在有限的时间里归还所有的资金。</p>
<p> </p>
<p>　　清单 1. 银行家算法实现</p>
<p>　　/*一共有5个进程需要请求资源，有3类资源*/</p>
<p>　　public class BankDemo {</p>
<p>　　// 每个进程所需要的最大资源数</p>
<p>　　public static int MAX[][] = { { 7, 5, 3 }, { 3, 2, 2 }, { 9, 0, 2 },</p>
<p>　　{ 2, 2, 2 }, { 4, 3, 3 } };</p>
<p>　　// 系统拥有的初始资源数</p>
<p>　　public static int AVAILABLE[] = { 10, 5, 7 };</p>
<p>　　// 系统已给每个进程分配的资源数</p>
<p>　　public static int ALLOCATION[][] = { { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 },</p>
<p>　　{ 0, 0, 0 }, { 0, 0, 0 } };</p>
<p>　　// 每个进程还需要的资源数</p>
<p>　　public static int NEED[][] = { { 7, 5, 3 }, { 3, 2, 2 }, { 9, 0, 2 },</p>
<p>　　{ 2, 2, 2 }, { 4, 3, 3 } };</p>
<p>　　// 每次申请的资源数</p>
<p>　　public static int Request[] = { 0, 0, 0 };</p>
<p>　　// 进程数与资源数</p>
<p>　　public static int M = 5, N = 3;</p>
<p>　　int FALSE = 0;</p>
<p>　　int TRUE = 1;</p>
<p>　　public void showdata() {</p>
<p>　　int i, j;</p>
<p>　　System.out.print("系统可用的资源数为:/n");</p>
<p>　　for (j = 0; j &lt; N; j++) {</p>
<p>　　System.out.print("资源" + j + ":" + AVAILABLE[j] + " ");</p>
<p>　　}</p>
<p>　　System.out.println();</p>
<p>　　System.out.println("各进程还需要的资源量:");</p>
<p>　　for (i = 0; i &lt; M; i++) {</p>
<p>　　System.out.print("进程" + i + ":");</p>
<p>　　for (j = 0; j &lt; N; j++) {</p>
<p>　　System.out.print("资源" + j + ":" + NEED[i][j] + " ");</p>
<p>　　}</p>
<p>　　System.out.print("/n");</p>
<p>　　}</p>
<p>　　System.out.print("各进程已经得到的资源量: /n");</p>
<p>　　for (i = 0; i &lt; M; i++) {</p>
<p>　　System.out.print("进程");</p>
<p>　　System.out.print(i);</p>
<p>　　for (j = 0; j &lt; N; j++) {</p>
<p>　　System.out.print("资源" + j + ":" + ALLOCATION[i][j] + " ");</p>
<p>　　}</p>
<p>　　System.out.print("/n");</p>
<p>　　}</p>
<p>　　}</p>
<p>　　// 分配资源，并重新更新各种状态</p>
<p>　　public void changdata(int k) {</p>
<p>　　int j;</p>
<p>　　for (j = 0; j &lt; N; j++) {</p>
<p>　　AVAILABLE[j] = AVAILABLE[j] - Request[j];</p>
<p>　　ALLOCATION[k][j] = ALLOCATION[k][j] + Request[j];</p>
<p>　　NEED[k][j] = NEED[k][j] - Request[j];</p>
<p>　　}</p>
<p>　　};</p>
<p>　　// 回收资源，并重新更新各种状态</p>
<p>　　public void rstordata(int k) {</p>
<p>　　int j;</p>
<p>　　for (j = 0; j &lt; N; j++) {</p>
<p>　　AVAILABLE[j] = AVAILABLE[j] + Request[j];</p>
<p>　　ALLOCATION[k][j] = ALLOCATION[k][j] - Request[j];</p>
<p>　　NEED[k][j] = NEED[k][j] + Request[j];</p>
<p>　　}</p>
<p>　　};</p>
<p>　　// 释放资源</p>
<p>　　public void free(int k) {</p>
<p>　　for (int j = 0; j &lt; N; j++) {</p>
<p>　　AVAILABLE[j] = AVAILABLE[j] + ALLOCATION[k][j];</p>
<p>　　System.out.print("释放" + k + "号进程的" + j + "资源!/n");</p>
<p>　　}</p>
<p>　　}</p>
<p>　　public int check0(int k) {</p>
<p>　　int j, n = 0;</p>
<p>　　for (j = 0; j &lt; N; j++) {</p>
<p>　　if (NEED[k][j] == 0)</p>
<p>　　n++;</p>
<p>　　}</p>
<p>　　if (n == 3)</p>
<p>　　return 1;</p>
<p>　　else</p>
<p>　　return 0;</p>
<p>　　}</p>
<p>　　// 检查安全性函数</p>
<p>　　//所以银行家算法其核心是：保证银行家系统的资源数至少不小于一个客户的所需要的资源数。在安全性检查函数 chkerr() 上由这个方法来实现</p>
<p>　　//这个循环来进行核心判断，从而完成了银行家算法的安全性检查工作。</p>
<p>　　public int chkerr(int s) {</p>
<p>　　int WORK;</p>
<p>　　int FINISH[] = new int[M], temp[] = new int[M];// 保存临时的安全进程序列</p>
<p>　　int i, j, k = 0;</p>
<p>　　for (i = 0; i &lt; M; i++)</p>
<p>　　FINISH[i] = FALSE;</p>
<p>　　for (j = 0; j &lt; N; j++) {</p>
<p>　　WORK = AVAILABLE[j]; // 第 j 个资源可用数</p>
<p>　　i = s;</p>
<p>　　// 判断第 i 个进程是否满足条件</p>
<p>　　while (i &lt; M) {</p>
<p>　　if (FINISH[i] == FALSE &amp;&amp; NEED[i][j] &lt;= WORK) {</p>
<p>　　WORK = WORK + ALLOCATION[i][j];</p>
<p>　　FINISH[i] = TRUE;</p>
<p>　　temp[k] = i;</p>
<p>　　k++;</p>
<p>　　i = 0;</p>
<p>　　} else {</p>
<p>　　i++;</p>
<p>　　}</p>
<p>　　}</p>
<p>　　for (i = 0; i &lt; M; i++)</p>
<p>　　if (FINISH[i] == FALSE) {</p>
<p>　　System.out.print("/n 系统不安全!!! 本次资源申请不成功!/n");</p>
<p>　　return 1;</p>
<p>　　}</p>
<p>　　}</p>
<p>　　System.out.print("/n 经安全性检查，系统安全，本次分配成功。/n");</p>
<p>　　System.out.print("本次安全序列：");</p>
<p>　　for (i = 0; i &lt; M - 1; i++) {</p>
<p>　　System.out.print("进程" + temp[i] + "-&gt;");</p>
<p>　　}</p>
<p>　　System.out.print("进程" + temp[M - 1]);</p>
<p>　　System.out.println("/n");</p>
<p>　　return 0;</p>
<p>　　}</p>
<p>　　}</p>
<p> </p>
<p>　　死锁示例</p>
<p>　　死锁问题是多线程特有的问题，它可以被认为是线程间切换消耗系统性能的一种极端情况。在死锁时，线程间相互等待资源，而又不释放自身的资源，导致无穷无尽的等待，其结果是系统任务永远无法执行完成。死锁问题是在多线程开发中应该坚决避免和杜绝的问题。</p>
<p>　　一般来说，要出现死锁问题需要满足以下条件：</p>
<p>　　1. 互斥条件：一个资源每次只能被一个线程使用。</p>
<p>　　2. 请求与保持条件：一个进程因请求资源而阻塞时，对已获得的资源保持不放。</p>
<p>　　3. 不剥夺条件：进程已获得的资源，在未使用完之前，不能强行剥夺。</p>
<p>　　4. 循环等待条件：若干进程之间形成一种头尾相接的循环等待资源关系。</p>
<p>　　只要破坏死锁 4 个必要条件之一中的任何一个，死锁问题就能被解决。</p>
<p>　　我们先来看一个示例，前面说过，死锁是两个甚至多个线程被永久阻塞时的一种运行局面，这种局面的生成伴随着至少两个线程和两个或者多个资源。代码清单 2 所示的示例中，我们编写了一个简单的程序，它将会引起死锁发生，然后我们就会明白如何分析它。</p>
<p> </p>
<p>　　清单 2. 死锁示例</p>
<p>　　public class ThreadDeadlock {</p>
<p>　　public static void main(String[] args) throws InterruptedException {</p>
<p>　　ob ject obj1 = new ob ject();</p>
<p>　　ob ject obj2 = new ob ject();</p>
<p>　　ob ject obj3 = new ob ject();</p>
<p>　　Thread t1 = new Thread(new SyncThread(obj1, obj2), "t1");</p>
<p>　　Thread t2 = new Thread(new SyncThread(obj2, obj3), "t2");</p>
<p>　　Thread t3 = new Thread(new SyncThread(obj3, obj1), "t3");</p>
<p>　　t1.start();</p>
<p>　　Thread.sleep(5000);</p>
<p>　　t2.start();</p>
<p>　　Thread.sleep(5000);</p>
<p>　　t3.start();</p>
<p>　　}</p>
<p>　　}</p>
<p>　　class SyncThread implements Runnable{</p>
<p>　　private ob ject obj1;</p>
<p>　　private ob ject obj2;</p>
<p>　　public SyncThread(ob ject o1, ob ject o2){</p>
<p>　　this.obj1=o1;</p>
<p>　　this.obj2=o2;</p>
<p>　　}</p>
<p>　　@Override</p>
<p>　　public void run() {</p>
<p>　　String name = Thread.currentThread().getName();</p>
<p>　　System.out.println(name + " acquiring lock on "+obj1);</p>
<p>　　synchronized (obj1) {</p>
<p>　　System.out.println(name + " acquired lock on "+obj1);</p>
<p>　　work();</p>
<p>　　System.out.println(name + " acquiring lock on "+obj2);</p>
<p>　　synchronized (obj2) {</p>
<p>　　System.out.println(name + " acquired lock on "+obj2);</p>
<p>　　work();</p>
<p>　　}</p>
<p>　　System.out.println(name + " released lock on "+obj2);</p>
<p>　　}</p>
<p>　　System.out.println(name + " released lock on "+obj1);</p>
<p>　　System.out.println(name + " finished execution.");</p>
<p>　　}</p>
<p>　　private void work() {</p>
<p>　　try {</p>
<p>　　Thread.sleep(30000);</p>
<p>　　} catch (InterruptedException e) {</p>
<p>　　e.printStackTrace();</p>
<p>　　}</p>
<p>　　}</p>
<p>　　}</p>
<p>　　在上面的程序中同步线程正完成 Runnable 的接口，它工作的是两个对象，这两个对象向对方寻求死锁而且都在使用同步阻塞。在主函数中，我使用了三个为同步线程运行的线程，而且在其中每个线程中都有一个可共享的资源。这些线程以向第一个对象获取封锁这种方式运行。但是当它试着向第二个对象获取封锁时，它就会进入等待状态，因为它已经被另一个线程封锁住了。这样，在线程引起死锁的过程中，就形成了一个依赖于资源的循环。当我执行上面的程序时，就产生了输出，但是程序却因为死锁无法停止。输出如清单 3 所示。</p>
<p> </p>
<p>　　清单 3. 清单 2 运行输出</p>
<p>　　t1 acquiring lock on java.lang.ob ject@1dd3812</p>
<p>　　t1 acquired lock on java.lang.ob ject@1dd3812</p>
<p>　　t2 acquiring lock on java.lang.ob ject@c791b9</p>
<p>　　t2 acquired lock on java.lang.ob ject@c791b9</p>
<p>　　t3 acquiring lock on java.lang.ob ject@1aa9f99</p>
<p>　　t3 acquired lock on java.lang.ob ject@1aa9f99</p>
<p>　　t1 acquiring lock on java.lang.ob ject@c791b9</p>
<p>　　t2 acquiring lock on java.lang.ob ject@1aa9f99</p>
<p>　　在此我们可以清楚地在输出结果中辨认出死锁局面，但是在我们实际所用的应用中，发现死锁并将它排除是非常难的。</p>
<p> </p>
<p>　　死锁情况诊断</p>
<p>　　JVM 提供了一些工具可以来帮助诊断死锁的发生，如下面程序清单 4 所示，我们实现了一个死锁，然后尝试通过 jstack 命令追踪、分析死锁发生。</p>
<p> </p>
<p>　　清单 4. 死锁代码</p>
<p>　　import java.util.concurrent.locks.ReentrantLock;</p>
<p>　　//下面演示一个简单的死锁，两个线程分别占用 south 锁和 north 锁，并同时请求对方占用的锁，导致死锁</p>
<p>　　public class DeadLock extends Thread{</p>
<p>　　protected ob ject myDirect;</p>
<p>　　static ReentrantLock south = new ReentrantLock();</p>
<p>　　static ReentrantLock north = new ReentrantLock();</p>
<p>　　public DeadLock(ob ject obj){</p>
<p>　　this.myDirect = obj;</p>
<p>　　if(myDirect==south){</p>
<p>　　this.setName("south");</p>
<p>　　}else{</p>
<p>　　this.setName("north");</p>
<p>　　}</p>
<p>　　}</p>
<p>　　@Override</p>
<p>　　public void run(){</p>
<p>　　if(myDirect==south){</p>
<p>　　try{</p>
<p>　　north.lockInterruptibly();//占用 north</p>
<p>　　try{</p>
<p>　　Thread.sleep(500);</p>
<p>　　}catch(Exception ex){</p>
<p>　　ex.printStackTrace();</p>
<p>　　}</p>
<p>　　south.lockInterruptibly();</p>
<p>　　System.out.println("car to south has passed");</p>
<p>　　}catch(InterruptedException ex){</p>
<p>　　System.out.println("car to south is killed");</p>
<p>　　ex.printStackTrace();</p>
<p>　　}finally{</p>
<p>　　if(north.isHeldByCurrentThread()){</p>
<p>　　north.unlock();</p>
<p>　　}</p>
<p>　　if(south.isHeldByCurrentThread()){</p>
<p>　　south.unlock();</p>
<p>　　}</p>
<p>　　}</p>
<p>　　}</p>
<p>　　if(myDirect==north){</p>
<p>　　try{</p>
<p>　　south.lockInterruptibly();//占用 south</p>
<p>　　try{</p>
<p>　　Thread.sleep(500);</p>
<p>　　}catch(Exception ex){</p>
<p>　　ex.printStackTrace();</p>
<p>　　}</p>
<p>　　north.lockInterruptibly();</p>
<p>　　System.out.println("car to north has passed");</p>
<p>　　}catch(InterruptedException ex){</p>
<p>　　System.out.println("car to north is killed");</p>
<p>　　ex.printStackTrace();</p>
<p>　　}finally{</p>
<p>　　if(north.isHeldByCurrentThread()){</p>
<p>　　north.unlock();</p>
<p>　　}</p>
<p>　　if(south.isHeldByCurrentThread()){</p>
<p>　　south.unlock();</p>
<p>　　}</p>
<p>　　}</p>
<p>　　}</p>
<p>　　}</p>
<p>　　public static void main(String[] args) throws InterruptedException{</p>
<p>　　DeadLock car2south = new DeadLock(south);</p>
<p>　　DeadLock car2north = new DeadLock(north);</p>
<p>　　car2south.start();</p>
<p>　　car2north.start();</p>
<p>　　}</p>
<p>　　}</p>
<p>　　jstack 可用于导出 Java 应用程序的线程堆栈，-l 选项用于打印锁的附加信息。我们运行 jstack 命令，输出入清单 5 和 6 所示，其中清单 5 里面可以看到线程处于运行状态，代码中调用了拥有锁投票、定时锁等候和可中断锁等候等特性的 ReentrantLock 锁机制。清单 6 直接打印出出现死锁情况，报告 north 和 sourth 两个线程互相等待资源，出现了死锁。</p>
<p> </p>
<p>　　清单 5. jstack 运行输出 1</p>
<p>　　[root@facenode4 ~]# jstack -l 31274</p>
<p>　　2015-01-29 12:40:27</p>
<p>　　Full thread dump Java HotSpot(TM) 64-Bit Server VM (20.45-b01 mixed mode):</p>
<p>　　"Attach Listener" daemon prio=10 tid=0x00007f6d3c001000 nid=</p>
<p>　　0x7a87 waiting on condition [0x0000000000000000]</p>
<p>　　java.lang.Thread.State: RUNNABLE</p>
<p>　　Locked ownable synchronizers:</p>
<p>　　- None</p>
<p>　　"DestroyJavaVM" prio=10 tid=0x00007f6da4006800 nid=</p>
<p>　　0x7a2b waiting on condition [0x0000000000000000]</p>
<p>　　java.lang.Thread.State: RUNNABLE</p>
<p>　　Locked ownable synchronizers:</p>
<p>　　- None</p>
<p>　　"north" prio=10 tid=0x00007f6da4101800 nid=</p>
<p>　　0x7a47 waiting on condition [0x00007f6d8963b000]</p>
<p>　　java.lang.Thread.State: WAITING (parking)</p>
<p>　　at sun.misc.Unsafe.park(Native Method)</p>
<p>　　- parking to wait for &lt;0x000000075903c7c8&gt; (</p>
<p>　　a java.util.concurrent.locks.ReentrantLock$NonfairSync)</p>
<p>　　at java.util.concurrent.locks.LockSupport.park(LockSupport.java:156)</p>
<p>　　at java.util.concurrent.locks.AbstractQueuedSynchronizer.</p>
<p>　　parkAndCheckInterrupt(AbstractQueuedSynchronizer.java:811)</p>
<p>　　at java.util.concurrent.locks.AbstractQueuedSynchronizer.</p>
<p>　　doAcquireInterruptibly(AbstractQueuedSynchronizer.java:867)</p>
<p>　　at java.util.concurrent.locks.AbstractQueuedSynchronizer.</p>
<p>　　acquireInterruptibly(AbstractQueuedSynchronizer.java:1201)</p>
<p>　　at java.util.concurrent.locks.ReentrantLock.lockInterruptibly(ReentrantLock.java:312)</p>
<p>　　at DeadLock.run(DeadLock.java:50)</p>
<p>　　Locked ownable synchronizers:</p>
<p>　　- &lt;0x000000075903c798&gt; (a java.util.concurrent.locks.ReentrantLock$NonfairSync)</p>
<p>　　"south" prio=10 tid=0x00007f6da4100000 nid=</p>
<p>　　0x7a46 waiting on condition [0x00007f6d8973c000]</p>
<p>　　java.lang.Thread.State: WAITING (parking)</p>
<p>　　at sun.misc.Unsafe.park(Native Method)</p>
<p>　　- parking to wait for &lt;0x000000075903c798&gt; (</p>
<p>　　a java.util.concurrent.locks.ReentrantLock$NonfairSync)</p>
<p>　　at java.util.concurrent.locks.LockSupport.park(LockSupport.java:156)</p>
<p>　　at java.util.concurrent.locks.AbstractQueuedSynchronizer.</p>
<p>　　parkAndCheckInterrupt(AbstractQueuedSynchronizer.java:811)</p>
<p>　　at java.util.concurrent.locks.AbstractQueuedSynchronizer.</p>
<p>　　doAcquireInterruptibly(AbstractQueuedSynchronizer.java:867)</p>
<p>　　at java.util.concurrent.locks.AbstractQueuedSynchronizer.</p>
<p>　　acquireInterruptibly(AbstractQueuedSynchronizer.java:1201)</p>
<p>　　at java.util.concurrent.locks.ReentrantLock.lockInterruptibly(ReentrantLock.java:312)</p>
<p>　　at DeadLock.run(DeadLock.java:28)</p>
<p>　　Locked ownable synchronizers:</p>
<p>　　- &lt;0x000000075903c7c8&gt; (a java.util.concurrent.locks.ReentrantLock$NonfairSync)</p>
<p>　　"Low Memory Detector" daemon prio=10 tid=0x00007f6da40d2800 nid=</p>
<p>　　0x7a44 runnable [0x0000000000000000]</p>
<p>　　java.lang.Thread.State: RUNNABLE</p>
<p>　　Locked ownable synchronizers:</p>
<p>　　- None</p>
<p>　　"C2 CompilerThread1" daemon prio=10 tid=0x00007f6da40d0000 nid=</p>
<p>　　0x7a43 waiting on condition [0x0000000000000000]</p>
<p>　　java.lang.Thread.State: RUNNABLE</p>
<p>　　Locked ownable synchronizers:</p>
<p>　　- None</p>
<p>　　"C2 CompilerThread0" daemon prio=10 tid=0x00007f6da40cd000 nid=</p>
<p>　　0x7a42 waiting on condition [0x0000000000000000]</p>
<p>　　java.lang.Thread.State: RUNNABLE</p>
<p>　　Locked ownable synchronizers:</p>
<p>　　- None</p>
<p>　　"Signal Dispatcher" daemon prio=10 tid=0x00007f6da40cb000 nid=</p>
<p>　　0x7a41 runnable [0x0000000000000000]</p>
<p>　　java.lang.Thread.State: RUNNABLE</p>
<p>　　Locked ownable synchronizers:</p>
<p>　　- None</p>
<p>　　"Finalizer" daemon prio=10 tid=0x00007f6da40af000 nid=</p>
<p>　　0x7a40 in ob ject.wait() [0x00007f6d89d44000]</p>
<p>　　java.lang.Thread.State: WAITING (on ob ject monitor)</p>
<p>　　at java.lang.ob ject.wait(Native Method)</p>
<p>　　- waiting on &lt;0x0000000759001300&gt; (a java.lang.ref.ReferenceQueue$Lock)</p>
<p>　　at java.lang.ref.ReferenceQueue.remove(ReferenceQueue.java:118)</p>
<p>　　- locked &lt;0x0000000759001300&gt; (a java.lang.ref.ReferenceQueue$Lock)</p>
<p>　　at java.lang.ref.ReferenceQueue.remove(ReferenceQueue.java:134)</p>
<p>　　at java.lang.ref.Finalizer$FinalizerThread.run(Finalizer.java:171)</p>
<p>　　Locked ownable synchronizers:</p>
<p>　　- None</p>
<p>　　"Reference Handler" daemon prio=10 tid=0x00007f6da40ad000 nid=</p>
<p>　　0x7a3f in ob ject.wait() [0x00007f6d89e45000]</p>
<p>　　java.lang.Thread.State: WAITING (on ob ject monitor)</p>
<p>　　at java.lang.ob ject.wait(Native Method)</p>
<p>　　- waiting on &lt;0x00000007590011d8&gt; (a java.lang.ref.Reference$Lock)</p>
<p>　　at java.lang.ob ject.wait(ob ject.java:485)</p>
<p>　　at java.lang.ref.Reference$ReferenceHandler.run(Reference.java:116)</p>
<p>　　- locked &lt;0x00000007590011d8&gt; (a java.lang.ref.Reference$Lock)</p>
<p>　　Locked ownable synchronizers:</p>
<p>　　- None</p>
<p>　　"VM Thread" prio=10 tid=0x00007f6da40a6000 nid=0x7a3e runnable</p>
<p>　　"GC task thread#0 (ParallelGC)" prio=10 tid=0x00007f6da4019800 nid=0x7a2c runnable</p>
<p>　　"GC task thread#1 (ParallelGC)" prio=10 tid=0x00007f6da401b000 nid=0x7a2d runnable</p>
<p>　　"GC task thread#2 (ParallelGC)" prio=10 tid=0x00007f6da401d000 nid=0x7a2e runnable</p>
<p>　　"GC task thread#3 (ParallelGC)" prio=10 tid=0x00007f6da401f000 nid=0x7a2f runnable</p>
<p>　　"GC task thread#4 (ParallelGC)" prio=10 tid=0x00007f6da4020800 nid=0x7a30 runnable</p>
<p>　　"GC task thread#5 (ParallelGC)" prio=10 tid=0x00007f6da4022800 nid=0x7a31 runnable</p>
<p>　　"GC task thread#6 (ParallelGC)" prio=10 tid=0x00007f6da4024800 nid=0x7a32 runnable</p>
<p>　　"GC task thread#7 (ParallelGC)" prio=10 tid=0x00007f6da4026000 nid=0x7a33 runnable</p>
<p>　　"GC task thread#8 (ParallelGC)" prio=10 tid=0x00007f6da4028000 nid=0x7a34 runnable</p>
<p>　　"GC task thread#9 (ParallelGC)" prio=10 tid=0x00007f6da402a000 nid=0x7a35 runnable</p>
<p>　　"GC task thread#10 (ParallelGC)" prio=10 tid=0x00007f6da402b800 nid=0x7a36 runnable</p>
<p>　　"GC task thread#11 (ParallelGC)" prio=10 tid=0x00007f6da402d800 nid=0x7a37 runnable</p>
<p>　　"GC task thread#12 (ParallelGC)" prio=10 tid=0x00007f6da402f800 nid=0x7a38 runnable</p>
<p>　　"GC task thread#13 (ParallelGC)" prio=10 tid=0x00007f6da4031000 nid=0x7a39 runnable</p>
<p>　　"GC task thread#14 (ParallelGC)" prio=10 tid=0x00007f6da4033000 nid=0x7a3a runnable</p>
<p>　　"GC task thread#15 (ParallelGC)" prio=10 tid=0x00007f6da4035000 nid=0x7a3b runnable</p>
<p>　　"GC task thread#16 (ParallelGC)" prio=10 tid=0x00007f6da4036800 nid=0x7a3c runnable</p>
<p>　　"GC task thread#17 (ParallelGC)" prio=10 tid=0x00007f6da4038800 nid=0x7a3d runnable</p>
<p>　　"VM Periodic Task Thread" prio=10 tid=0x00007f6da40dd000 nid=0x7a45 waiting on condition</p>
<p>　　JNI global references: 886</p>
<p>　　清单 6. jstack 运行输出片段 2</p>
<p>　　Found one Java-level deadlock:</p>
<p>　　=============================</p>
<p>　　"north":</p>
<p>　　waiting for ownable synchronizer 0x000000075903c7c8, (</p>
<p>　　a java.util.concurrent.locks.ReentrantLock$NonfairSync),</p>
<p>　　which is held by "south"</p>
<p>　　"south":</p>
<p>　　waiting for ownable synchronizer 0x000000075903c798, (</p>
<p>　　a java.util.concurrent.locks.ReentrantLock$NonfairSync),</p>
<p>　　which is held by "north"</p>
<p>　　Java stack information for the threads listed above:</p>
<p>　　===================================================</p>
<p>　　"north":</p>
<p>　　at sun.misc.Unsafe.park(Native Method)</p>
<p>　　- parking to wait for &lt;0x000000075903c7c8&gt; (</p>
<p>　　a java.util.concurrent.locks.ReentrantLock$NonfairSync)</p>
<p>　　at java.util.concurrent.locks.LockSupport.park(LockSupport.java:156)</p>
<p>　　at java.util.concurrent.locks.AbstractQueuedSynchronizer.</p>
<p>　　parkAndCheckInterrupt(AbstractQueuedSynchronizer.java:811)</p>
<p>　　at java.util.concurrent.locks.AbstractQueuedSynchronizer.</p>
<p>　　doAcquireInterruptibly(AbstractQueuedSynchronizer.java:867)</p>
<p>　　at java.util.concurrent.locks.AbstractQueuedSynchronizer.</p>
<p>　　acquireInterruptibly(AbstractQueuedSynchronizer.java:1201)</p>
<p>　　at java.util.concurrent.locks.ReentrantLock.lockInterruptibly(ReentrantLock.java:312)</p>
<p>　　at DeadLock.run(DeadLock.java:50)</p>
<p>　　"south":</p>
<p>　　at sun.misc.Unsafe.park(Native Method)</p>
<p>　　- parking to wait for &lt;0x000000075903c798&gt; (</p>
<p>　　a java.util.concurrent.locks.ReentrantLock$NonfairSync)</p>
<p>　　at java.util.concurrent.locks.LockSupport.park(LockSupport.java:156)</p>
<p>　　at java.util.concurrent.locks.AbstractQueuedSynchronizer.</p>
<p>　　parkAndCheckInterrupt(AbstractQueuedSynchronizer.java:811)</p>
<p>　　at java.util.concurrent.locks.AbstractQueuedSynchronizer.</p>
<p>　　doAcquireInterruptibly(AbstractQueuedSynchronizer.java:867)</p>
<p>　　at java.util.concurrent.locks.AbstractQueuedSynchronizer.</p>
<p>　　acquireInterruptibly(AbstractQueuedSynchronizer.java:1201)</p>
<p>　　at java.util.concurrent.locks.ReentrantLock.lockInterruptibly(ReentrantLock.java:312)</p>
<p>　　at DeadLock.run(DeadLock.java:28)</p>
<p>　　Found 1 deadlock.</p>
<p> </p>
<p>　　死锁解决方案</p>
<p>　　死锁是由四个必要条件导致的，所以一般来说，只要破坏这四个必要条件中的一个条件，死锁情况就应该不会发生。</p>
<p>　　如果想要打破互斥条件，我们需要允许进程同时访问某些资源，这种方法受制于实际场景，不太容易实现条件;</p>
<p>　　打破不可抢占条件，这样需要允许进程强行从占有者那里夺取某些资源，或者简单一点理解，占有资源的进程不能再申请占有其他资源，必须释放手上的资源之后才能发起申请，这个其实也很难找到适用场景;</p>
<p>　　进程在运行前申请得到所有的资源，否则该进程不能进入准备执行状态。这个方法看似有点用处，但是它的缺点是可能导致资源利用率和进程并发性降低;</p>
<p>　　避免出现资源申请环路，即对资源事先分类编号，按号分配。这种方式可以有效提高资源的利用率和系统吞吐量，但是增加了系统开销，增大了进程对资源的占用时间。</p>
<p> </p>
<p>　　如果我们在死锁检查时发现了死锁情况，那么就要努力消除死锁，使系统从死锁状态中恢复过来。消除死锁的几种方式：</p>
<p>　　1. 最简单、最常用的方法就是进行系统的重新启动，不过这种方法代价很大，它意味着在这之前所有的进程已经完成的计算工作都将付之东流，包括参与死锁的那些进程，以及未参与死锁的进程;</p>
<p>　　2. 撤消进程，剥夺资源。终止参与死锁的进程，收回它们占有的资源，从而解除死锁。这时又分两种情况：一次性撤消参与死锁的全部进程，剥夺全部资源;或者逐步撤消参与死锁的进程，逐步收回死锁进程占有的资源。一般来说，选择逐步撤消的进程时要按照一定的原则进行，目的是撤消那些代价最小的进程，比如按进程的优先级确定进程的代价;考虑进程运行时的代价和与此进程相关的外部作业的代价等因素;</p>
<p>　　3. 进程回退策略，即让参与死锁的进程回退到没有发生死锁前某一点处，并由此点处继续执行，以求再次执行时不再发生死锁。虽然这是个较理想的办法，但是操作起来系统开销极大，要有堆栈这样的机构记录进程的每一步变化，以便今后的回退，有时这是无法做到的。</p>
<p>　　其实即便是商业产品，依然会有很多死锁情况的发生，例如 MySQL 数据库，它也经常容易出现死锁案例。</p>
<p> </p>
<p>　　MySQL 死锁情况解决方法</p>
<p>　　假设我们用 Show innodb status 检查引擎状态时发现了死锁情况，如清单 7 所示。</p>
<p> </p>
<p>　　清单 7. MySQL 死锁</p>
<p>　　WAITING FOR THIS LOCK TO BE GRANTED:</p>
<p>　　RECORD LOCKS space id 0 page no 843102 n bits 600 index `KEY_TSKTASK_MONTIME2` of table</p>
<p>　　`dcnet_db/TSK_TASK` trx id 0 677833454 lock_mode X locks rec but not gap waiting</p>
<p>　　Record lock, heap no 395 PHYSICAL RECORD: n_fields 3; compact format; info bits 0</p>
<p>　　0: len 8; hex 8000000000000425; asc %;; 1: len 8; hex 800012412c66d29c;</p>
<p>　　asc A,f ;; 2: len 8; hex 800000000097629c; asc b ;;</p>
<p>　　*** WE ROLL BACK TRANSACTION (1)</p>
<p>　　我们假设涉事的数据表上面有一个索引，这次的死锁就是由于两条记录同时访问到了相同的索引造成的。</p>
<p> </p>
<p>　　我们首先来看看 InnoDB 类型的数据表，只要能够解决索引问题，就可以解决死锁问题。MySQL 的 InnoDB 引擎是行级锁，需要注意的是，这不是对记录进行锁定，而是对索引进行锁定。在 UPDATE、DELETE 操作时，MySQL 不仅锁定 WHERE 条件扫描过的所有索引记录，而且会锁定相邻的键值，即所谓的 next-key locking;</p>
<p> </p>
<p>　　如语句 UPDATE TSK_TASK SET UPDATE_TIME = NOW() WHERE ID &gt; 10000 会锁定所有主键大于等于 1000 的所有记录，在该语句完成之前，你就不能对主键等于 10000 的记录进行操作;当非簇索引 (non-cluster index) 记录被锁定时，相关的簇索引 (cluster index) 记录也需要被锁定才能完成相应的操作。</p>
<p> </p>
<p>　　再分析一下发生问题的两条 SQL 语句：</p>
<p>　　当“update TSK_TASK set STATUS_ID=1064,UPDATE_TIME=now () where STATUS_ID=1061 and MON_TIME&lt;date_sub(now(), INTERVAL 30 minute)”执行时，MySQL 会使用 KEY_TSKTASK_MONTIME2 索引，因此首先锁定相关的索引记录，因为 KEY_TSKTASK_MONTIME2 是非簇索引，为执行该语句，MySQL 还会锁定簇索引(主键索引)。</p>
<p> </p>
<p>　　假设“update TSK_TASK set STATUS_ID=1067,UPDATE_TIME=now () where ID in (9921180)”几乎同时执行时，本语句首先锁定簇索引 (主键)，由于需要更新 STATUS_ID 的值，所以还需要锁定 KEY_TSKTASK_MONTIME2 的某些索引记录。</p>
<p> </p>
<p>　　这样第一条语句锁定了 KEY_TSKTASK_MONTIME2 的记录，等待主键索引，而第二条语句则锁定了主键索引记录，而等待 KEY_TSKTASK_MONTIME2 的记录，这样死锁就产生了。</p>
<p>　　我们通过拆分第一条语句解决了死锁问题：即先查出符合条件的 ID：select ID from TSK_TASK where STATUS_ID=1061 and MON_TIME &lt; date_sub(now(), INTERVAL 30 minute);然后再更新状态：update TSK_TASK set STATUS_ID=1064 where ID in (….)。</p>
<p> </p>
<p>　　结束语</p>
<p>　　我们发现，死锁虽然是较早就被发现的问题，但是很多情况下我们设计的程序里还是经常发生死锁情况。我们不能只是分析如何解决死锁这类问题，还需要具体找出预防死锁的方法，这样才能从根本上解决问题。总的来说，还是需要系统架构师、程序员不断积累经验，从业务逻辑设计层面彻底消除死锁发生的可能性</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:53:52</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/public/" title="public">public</a>, <a href="https://www.iamivan.net/tag/%e8%b5%84%e6%ba%90/" title="资源">资源</a>, <a href="https://www.iamivan.net/tag/%e8%bf%9b%e7%a8%8b/" title="进程">进程</a>, <a href="https://www.iamivan.net/tag/system/" title="system">system</a>, <a href="https://www.iamivan.net/tag/int/" title="int">int</a>, <a href="https://www.iamivan.net/tag/%e6%ad%bb%e9%94%81/" title="死锁">死锁</a>, <a href="https://www.iamivan.net/tag/java-%e8%bf%9b%e7%a8%8b%e6%ad%bb%e9%94%81/" title="java 进程死锁">java 进程死锁</a>, <a href="https://www.iamivan.net/tag/%e6%ad%bb%e9%94%81%e9%97%ae%e9%a2%98/" title="死锁问题">死锁问题</a>, <a href="https://www.iamivan.net/tag/%e9%93%b6%e8%a1%8c%e5%ae%b6%e7%ae%97%e6%b3%95/" title="银行家算法">银行家算法</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java 程序死锁问题原理及解决方案的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZBPJ6z.html" rel="bookmark">jar-为什么要将java程序JAR包打包成&period;EXE&comma;作用是什么</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 为什么要将java程序JAR包打包成.EXE,作用是什么 如题.jar包不是已经能运行了吗,为何还要打包成.EXE呢,求真解,意义何在? 解决方案 JAR包不能单独运行的,它只是将一些函数封装下,提供给其它工程使用,要依托java.EXE是可以单独运行的,不用依托java 解决方案二: Java程序打包成Jar包Java程序打包成jar包Java程序打包成jar包 解决方案三: http://blog.chinaunix.net/uid-26153556-id-3042913.html			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRdyYaz.html" rel="bookmark">class-cmd编译java程序时的一个问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 cmd编译java程序时的一个问题 使用javac编译一个java程序时,如果该java文件导入了其他的类,只能将导入的类一个一个手动编译吗?有没有什么其他便捷的方法? 解决方案 Exception in thread &quot;main&quot; java.lang.NoClassDefFoundError: comexampleMain 问题一个解决思路......答案就在这里:编译java程序时的一个问题 解决方案二: 如果是测试的话你也可以把其他类嵌套到一个类测试,这样就可以监测其功			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgRY88b.html" rel="bookmark">优秀Java程序员必须了解的GC工作原理（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一个优秀的Java程序员必须了解GC(Garbage Collection 垃圾收集)的工作原理.如何优化GC的性能.如何与GC进行有限的交互,因为有一些应用程序对性能要求较高,例如嵌入式系统.实时系统等,只有全面提升内存的管理效率 ,才能提高整个应用程序的性能.本篇文章首先简单介绍GC的工作原理之后,然后再对GC的几个关键问题进行深入探讨,最后提出一些Java程序设计建议,从GC角度提高Java程序的性能. GC的基本原理 Java的内存管理实际上就是对象的管理,其中包括对象的分配和释放. 对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMgEDEz.html" rel="bookmark">Java程序员面试题集（86-115）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java程序员面试题集(86-115) 摘要:下面的内容包括Struts 2和Hibernate的常见面试题,虽然Struts 2在2013年6月曝出高危漏洞后已经显得江河日下,而Spring MVC的异军突起更加加速了Struts 2的陨落,但面试中仍然有可能被问及和此框架相关的内容,毕竟Struts 2曾经被阿里巴巴.京东以及政府企业门户网站广泛采用.另一方面,Hibernate目前仍然是ORM框架中的中坚力量,MyBatis在此领域也有不容忽视的一席之地,因此了解这两个ORM框架对Java			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/7b29AVz.html" rel="bookmark">Java规则引擎工作原理及其应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘 要 Java规则引擎是一种嵌入在Java程序中的组件,它的任务是把当前提交给引擎的Java数据对象与加载在引擎中的业务规则进行测试和比对,激活那些符合当前数据状态下的业务规则,根据业务规则中声明的执行逻辑,触发应用程序中对应的操作. 引言 目前,Java社区推动并发展了一种引人注目的新技术--Java规则引擎(Rule Engine).利用它就可以在应用系统中分离商业决策者的商业决策逻辑和应用开发者的技术决策,并把这些商业决策放在中心数据库或其他统一的地方,让它们能在运行时可以动态地管理和修			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0boYwjp.html" rel="bookmark">Java 程序中的多线程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				程序|多线程 在Java程序中使用多线程要比在 C 或 C++ 中容易得多,这是因为 Java 编程语言提供了语言级的支持.本文通过简单的编程示例来说明 Java 程序中的多线程是多么直观.读完本文以后,用户应该能够编写简单的多线程程序. 为什么会排队等待? 下面的这个简单的 Java 程序完成四项不相关的任务.这样的程序有单个控制线程,控制在这四个任务之间线性地移动.此外,因为所需的资源 - 打印机.磁盘.数据库和显示屏 -- 由于硬件和软件的限制都有内在的潜伏时间,所以每项任务都包含			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqL9Kab.html" rel="bookmark">浅析java程序中hibernate的应用总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				hibernate可以理解为是一个中间件它负责把java程序的sql语句接收过来发送到数据库,而数据库返回来的信息hibernate接收之后直接生成一个对象传给java   我们知道如果用java连接数据库,大量的SQL代码,我们就想通过一种工具来操作数据库, 我们首先想到的就是JDBC,但是想更好的针对类的属性进行操作,我们会选择Hibernate. 那么Hibernate 原理是什么呢?hibernate可以理解为是一个中间件它负责把java程序的sql语句接收过来发送到数据库, 而数据库返			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b24gWkp.html" rel="bookmark">请不要说自己是 Java 程序员</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				几年前 Reddit 上有个关于招聘的笑话:  面试官问:你用过 Python 或者 Django 吗? 答:我三周前去过动物园,这个算吗? 面试官:你被雇佣了. 一周后,这位应聘者用 Django 给他们的产品写了一个在线论坛. 英文的玩笑,用中文看有点不太容易懂.它的意思就是一个关于 Python(蟒蛇)经验只有三周前去过一次动物园的程序员,只要他足够的好,他也可以用一周的时间,基于 Python/Django 完成一个在线论坛. 经常在网上看到各种标题为&quot;Java程序员&quot;.&qu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkG6mEp.html" rel="bookmark">请不要说自己是Java程序员</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				几年前 Reddit 上有个关于招聘的笑话: 面试官问:你用过 Python 或者 Django 吗? 答:我三周前去过动物园,这个算吗? 面试官:你被雇佣了. 一周后,这位应聘者用 Django 给他们的产品写了一个在线论坛. 英文的玩笑,用中文看有点不太容易懂.它的意思就是一个关于 Python(蟒蛇)经验只有三周前去过一次动物园的程序员,只要他足够的好,他也可以用一周的时间,基于 Python/Django 完成一个在线论坛. 经常在网上看到各种标题为&quot;Java程序员&quot;.&quo			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2JnVb.html" rel="bookmark" class="title">Seajs是什么及其优缺点&amp;amp&semi;amp&semi;如何使用？</a>
					<div>
						这篇文章主要介绍了Seajs的相关知识和和学习心得,适合刚接触SeaJS的同学,需要的朋友可以参考下,有更好的新手教程或文档,欢迎推荐.分享! 1.Seajs简介   Seajs,一个Web模块加载框 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bB7NKM.html" rel="bookmark" class="title">用户体验已成搜索引擎评价网站首要标准</a>
					<div>
						百度站长平台发布Web2.0反垃圾详细攻略 Admin5站长网5月2日消息,今日百度站长平台发布&lt;Web2.0反垃圾详细攻略&gt;针对目前国内网站大量存在的群发垃圾信息,明确给出判断标准和应对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1q28M.html" rel="bookmark" class="title">DB2上机操作指令指南</a>
					<div>
						1. 启动实例(db2inst1): db2start 2. 停止实例(db2inst1): db2stop 3. 列出所有实例(db2inst1) db2ilist 5.列出当前实例: db2 ge ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNE5exb.html" rel="bookmark" class="title">win7系统Word自动恢复功能怎么使用</a>
					<div>
						win7系统Word自动恢复功能怎么使用   Word自动恢复 Word自动恢复功能的两个使用技巧: 1.Word的定时保存文件功能有一定局限性,只对DOC格式文件有效,如果是其他格式的文件则不能保存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJLd3p.html" rel="bookmark" class="title">数据狗恢复SD卡误删照片教程</a>
					<div>
						  第一步:打开您电脑中的数据狗数据恢复软件,进入软件主界面,选择&quot;误删除恢复&quot;模式,如下图所示. 第二步:在区域1内选中SD卡,点击区域2的确定键,进入数据恢复进度条. 第三步: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB19POz.html" rel="bookmark" class="title">欧洲市场需求重启 光伏产业将&OpenCurlyDoubleQuote;王者归来&rdquo;</a>
					<div>
						欧洲主要国家光伏政策将在5月逐步明朗,电站的建设需求有望被重新触发,光伏需求在6月将出现一个久违的小高潮.而国内相关企业届时也将有望迎来爆发. 欧洲市场重启动光伏需求六月或现小高潮 去年欧洲市场带动了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1r7mrp.html" rel="bookmark" class="title">qt制作计算器，计算器的类型转化</a>
					<div>
						问题描述 qt制作计算器,计算器的类型转化 标准型到科学型的转变应该如何进行,是需要两个ui么,如果是怎么进行切换的,或者有别的什么思路,求help 解决方案 最简单的是把高级功能放在界面的另一边,通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKo3Yb.html" rel="bookmark" class="title">Android开发之搜Ya项目----项目结构说明</a>
					<div>
						项目 搜芽移动客户端 项目包结构,日志,编码说明 作者 曾金龙 时间 2014-10-13 说明 简要说明工程结构,使用的log4j日志系统和UTF-8编码 第一部分:解决工程乱码问题 在window ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLPr5p.html" rel="bookmark" class="title">RDS SQL Server - 最佳实践 - 高CPU使用率系列之非SARG查询</a>
					<div>
						摘要 阿里云RDS SQL Server客户遇到最多的一个问题便是高CPU使用率导致导致SQL Server服务响应缓慢,查询超时,甚至服务挂起僵死.本系列文章第四篇分析非SARG查询导致CPU的高利 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDa43z.html" rel="bookmark" class="title">通过freemarker生成一个word&comma;解决生成的word用wps打开有问题的问题，解决出word时中文文件名乱码问题，解决打开出word时打开的word出现问题的问题，出图片，解决动态列表</a>
					<div>
						﻿﻿ 通过freemarker制作word比较简单 步骤:制作word模板.制作方式是:将模板word保存成为xml----在xml的word模板中添加相应的标记----将xml的word文件的后缀名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAgqQM.html" rel="bookmark" class="title">如何从出行无线覆盖到智慧交通演变，锐捷智慧交通解决方案有一套</a>
					<div>
						无论哪种交通工具没有无线Wi-Fi上网,都不能被称为一次愉快的出行.或许有点夸张的成分,但从现在人们对无线Wi-Fi上网的需求来看,智慧交通的出行必然要有无线Wi-Fi的身影.从陆地的上的高铁.地铁. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDe14Wb.html" rel="bookmark" class="title">清空file文件上传域jquery与js方法</a>
					<div>
						在IE下复制元素的时候,其中的值是不会被复制的,所以就达到了清空文件域的目的了.而在Firefox下,其中的值也会被一同复制,那么我们就顺便清空一下就做到兼容了.代码如下:  代码如下 复制代码 va ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY58N5M.html" rel="bookmark" class="title">link环境下找不到zipfile类，是用的codefirst，请问是怎么回事？</a>
					<div>
						问题描述 link环境下找不到zipfile类,是用的codefirst,请问是怎么回事? link环境下找不到zipfile类,是用的codefirst,请问是怎么回事? 解决方案 using Sy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmv99M.html" rel="bookmark" class="title">编译程序的时候出现的问题，求指导。</a>
					<div>
						问题描述 namespaceldr{usingSystem;usingSystem.Collections;usingSystem.ComponentModel;usingSystem.Drawing ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNDQBM.html" rel="bookmark" class="title">那类网站放Google adsense广告好</a>
					<div>
						1. 增加Google AdSense的展示效果,理论上是页面越多,展示的就越多.但是Google AdSense让你赚钱的是CPC而不是CPM,想法增加你的有效点击才是你赚钱的根本.也许你要说,10 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoj6xM.html" rel="bookmark" class="title">Yelp的实时流技术之三：不止是模式存储服务的Schematizer</a>
					<div>
						这是关于Yelp的实时流数据基础设施系列文章的第三篇.这个系列会深度讲解我们如何用&quot;确保只有一次&quot;的方式把MySQL数据库中的改动实时地以流的方式传输出去,我们如何自动跟踪表模式变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22mXkb.html" rel="bookmark" class="title">vb-VB处理access数据库的问题&comma;关于筛选值的问题</a>
					<div>
						问题描述 VB处理access数据库的问题,关于筛选值的问题 具体举例:CN 字段1 字段2 字段3-- 1 2.33 0 3.54-- -- 想通过VB编程来实现每一个CN对应的字段1.字段2--的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoDO0M.html" rel="bookmark" class="title">c语言编程-调用文件重命名函数rename失败，errno的值为17，如何解决？</a>
					<div>
						问题描述 调用文件重命名函数rename失败,errno的值为17,如何解决? void onMenuDele(char *id) { FILE *p=fopen(&quot;f:employee.t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3J8D3z.html" rel="bookmark" class="title">eclipse java-【求助】 新人想做个错题功能 有点难求教方法</a>
					<div>
						问题描述 [求助] 新人想做个错题功能 有点难求教方法 去掉前面的判断 通过用户ID找到数据库中的数据 然后提取到自己的数据库中 然后显示到页面上··· 该怎么实现					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBaLBz.html" rel="bookmark" class="title">Google的牛人们都来自哪些公司</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   之前我们曾报道了近期苹果离职员工的去向,其中最大的两个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvn0Q9M.html" rel="bookmark" class="title">求一个数字字母的JAVA验证码&excl;</a>
					<div>
						问题描述 如题!但是不需要在网页上运行!只要在电脑里直接打开就可以!在线等!求不要出现webservlet了... 解决方案 解决方案二:/****/importjava.awt.*;importja ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkEyvM.html" rel="bookmark" class="title">《数据库技术原理与应用教程》一1-6数据处理</a>
					<div>
						1-6数据处理 当今,由于数据与人类社会的密切关系,数据处理已成为计算机应用的重要内容.在本书中,数据处理主要指的是数据库中数据的应用. 1.6.1数据处理的环境 在数据处理中,数据存放于计算机中,用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5W2np.html" rel="bookmark" class="title">网络自制剧杀入电视节</a>
					<div>
						网站将投拍电视台限播的或者无法播放的特殊题材 第16届上海电视节将于6月7日拉开帷幕.在昨天举行的新闻发布会上,电视节组委会表示,今年最大亮点是,网络自制剧大抢风头,目前主要展台都被网络&quot;预 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvmqJM.html" rel="bookmark" class="title">node-webkit打包成exe文件被360误报木马的解决方法&lowbar;node&period;js</a>
					<div>
						最近项目需要用到node-webkit.处理古老级用户的兼容以及他们心里的'数据安全'问题. 1.下载完node-webkit 2.制作appName.nw文件 3.copy /b nw.exe+ap ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNOO9p.html" rel="bookmark" class="title">gridControl加载EXCEL数据的问题。</a>
					<div>
						问题描述 gridControl可以导出EXCEL,我按照这个导出的EXCEL文件,再导进来该如何做?PS.gridControl中用的是bandedGridView,采用的是强类型的DATASET读 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Zg1kb.html" rel="bookmark" class="title">C&num;控制台应用程序怎么创建一个 注册，登录程序</a>
					<div>
						问题描述 创建一个停车场管理系统登陆的控制台应用程序.运行程序显示登陆界面,如图16.用户选择是注册时,要求输入用户名和密码,即注册成功,返回登陆菜单项.用户选择登陆时,要求输入用户名和密码,正确时, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj840dp.html" rel="bookmark" class="title">科普文：从大数据到Hadoop，Spark，Storm</a>
					<div>
						大数据,官方定义是指那些数据量特别大.数据类别特别复杂的数据集,这种数据集无法用传统的数据库进行存储,管理和处理.大数据的主要特点为数据量大(Volume),数据类别复杂(Variety),数据处理速 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Y1k6p.html" rel="bookmark" class="title">hibernate级联查询的问题</a>
					<div>
						问题描述 根据项目要求,在每个表中加了删除标志deleted_flag,删除用1标志,未删除用0标志.在用hibernate本身的级联查询会把之前的子表已经删除的数据也检索出来.求最好的解决方法.问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJeN3Vp.html" rel="bookmark" class="title">xterm patch &num;276发布 X Window系统终端仿真器</a>
					<div>
						xterm程序是一个标准的X Window系统终端仿真器.它提供DEC VT102/VT220和Tektronix 4014程序的兼容终端,该程序不能直接使用窗口系统.如果底层操作系统支持终端的调整大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK3RWdb.html" rel="bookmark" class="title">上海医药内斗白热化一封举报信撂倒30亿资金</a>
					<div>
						5月23日,有上海医药(601607.SH)内部高管爆料指称:&quot;公司最近两次收购存在严重财务造假,并已被证监会和港交所调查,并称可能是下一个博士蛙(01698.HK).&quot; 公司A股 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.069 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
